import { Component, Input, ViewChild, ViewEncapsulation } from '@angular/core';
import Prism from 'prismjs';
export class PrismComponent {
    constructor() {
        this.async = false;
        this.callback = undefined;
    }
    set code(value) {
        this._code = value;
    }
    get code() {
        return this._code;
    }
    ngAfterViewChecked() {
        this.highlight();
    }
    highlight() {
        if (this.code && this.codeElementRef) {
            this.codeElementRef.nativeElement.innerHTML = Prism.highlight(this.code, Prism.languages[this.language]);
        }
        else if (this.codeElementRef) {
            this.highlightElement(this.codeElementRef.nativeElement, this.async, this.callback);
        }
        else {
            this.highlightAll(this.async, this.callback);
        }
    }
    highlightElement(element, async, callback) {
        Prism.highlightElement(element, async, callback);
    }
    highlightAll(async, callback) {
        Prism.highlightAll(async, callback);
    }
}
PrismComponent.decorators = [
    { type: Component, args: [{
                encapsulation: ViewEncapsulation.None,
                selector: 'prism-highlight',
                template: `{{code}}<pre class="language-{{language}}" *ngIf="language">
  <code class="language-{{language}}" *ngIf="!code" #codeElementRef><ng-content></ng-content></code>
  <code class="language-{{language}}" *ngIf="code" #codeElementRef></code>
</pre>`
            },] },
];
PrismComponent.ctorParameters = () => [];
PrismComponent.propDecorators = {
    'code': [{ type: Input, args: ['code',] },],
    'async': [{ type: Input, args: ['async',] },],
    'callback': [{ type: Input, args: ['callback',] },],
    'language': [{ type: Input, args: ['language',] },],
    'codeElementRef': [{ type: ViewChild, args: ['codeElementRef',] },],
};
//# sourceMappingURL=prism.component.js.map